%%
% M = loadshape('data/scape/12K/mesh001.tri');
% N = loadshape('data/scape/12K/mesh011.tri');

M.TRIV = load('../ex8supp/mesh001.tri');
M.VERT = load('../ex8supp/mesh001.vert');
M.X = M.VERT(:,1);M.Y = M.VERT(:,2);M.Z = M.VERT(:,3);

N.TRIV = load('../ex8supp/mesh011.tri');
N.VERT = load('../ex8supp/mesh011.vert');
N.X = N.VERT(:,1);N.Y = N.VERT(:,2);N.Z = N.VERT(:,3);

%%
M.M = mass_matrix(M.VERT,M.TRIV);
M.S = stiffness_matrix(M.VERT,M.TRIV);

N.M = mass_matrix(N.VERT,N.TRIV);
N.S = stiffness_matrix(N.VERT,N.TRIV);

%%
K = 200; %number of eigenfunctions

[M.phi,M.lambda] = eigs(-M.S,M.M,K,1e-5);
M.lambda = diag(M.lambda);

[N.phi,N.lambda] = eigs(-N.S,N.M,K,1e-5);
N.lambda = diag(N.lambda);


%%
figure()
for i=1:4
   subplot(2,4,i)
   trisurf(M.TRIV,M.X,M.Y,M.Z,M.phi(:,i));
   axis equal, shading interp,%colorbar
   subplot(2,4,i+4)
   trisurf(N.TRIV,N.X,N.Y,N.Z,M.phi(:,i));
   axis equal, shading interp,%colorbar
end
%%
figure()
scatter3(M.phi(:,2),M.phi(:,3),M.phi(:,4),5,'b','filled')
hold on
scatter3(N.phi(:,2),N.phi(:,3),N.phi(:,4),5,'r','filled')
hold on

%%
figure();
plot([M.lambda,N.lambda]);

