function [ S ] = stiffness_matrix( V, F )
%COTANMATRIX_NEW Summary of this function goes here
%   Detailed explanation goes here


if  (size(V,2)~=3)
    V = V';
end
assert(size(V,2)==3);
n = length(V);
if  (size(F,2)~=3)
    F = F';
end
assert(size(F,2)==3);

%% Compute matrix containing the cotangens-values
vm = V(F(:,1),:);
vn = V(F(:,2),:);
vk = V(F(:,3),:);

size(vm);
% calculate edge lengths
vmn = sqrt(sum((vm-vn).^2,2));
vnk = sqrt(sum((vn-vk).^2,2));
vkm = sqrt(sum((vk-vm).^2,2));

cosam = (vmn.^2.+vkm.^2-vnk.^2)./(2*vmn.*vkm);
cosan = (vnk.^2+vmn.^2.-vkm.^2)./(2*vnk.*vmn);
cosak = (vkm.^2+vnk.^2.-vmn.^2)./(2*vkm.*vnk);

cotam = cosam ./ sqrt(1-cosam.^2);
cotan = cosan ./ sqrt(1-cosan.^2);
cotak = cosak ./ sqrt(1-cosak.^2);

A = 0.5*[cotam cotan cotak];

i = [    F(:,1);    F(:,1);  F(:,1);  F(:,2);      F(:,2);    F(:,2);  F(:,3);  F(:,3);      F(:,3)];
j = [    F(:,1);    F(:,2);  F(:,3);  F(:,1);      F(:,2);    F(:,3);  F(:,1);  F(:,2);      F(:,3)];
s = [A(:,3)+A(:,2); -A(:,3); -A(:,2); -A(:,3); A(:,3)+A(:,1); -A(:,1); -A(:,2); -A(:,1); A(:,1)+A(:,2)];

S = sparse(i,j,s,n,n);


end


